<!--

        This file is part of the Squashtest platform.
        Copyright (C) Henix, henix.fr

        See the NOTICE file distributed with this work for additional
        information regarding copyright ownership.

        This is free software: you can redistribute it and/or modify
        it under the terms of the GNU Lesser General Public License as published by
        the Free Software Foundation, either version 3 of the License, or
        (at your option) any later version.

        this software is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU Lesser General Public License for more details.

        You should have received a copy of the GNU Lesser General Public License
        along with this software.  If not, see <http://www.gnu.org/licenses/>.

-->
<databaseChangeLog xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
                   xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
                   xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-2.0.xsd">

  <changeSet id="tm-7.1.0" author="mbrugniere">
    <comment>Update TM database version number</comment>
    <update tableName="CORE_CONFIG">
      <column name="VALUE" value="7.1.0"/>
      <where>STR_KEY = 'squashtest.tm.database.version'</where>
    </update>
  </changeSet>

  <changeSet id="tm-7.1.0-create-api-token-table" author="mbrugniere">
    <comment>Create table API_TOKEN</comment>
    <createTable tableName="API_TOKEN">
      <column name="TOKEN_ID" autoIncrement="true" type="BIGINT" remarks="primary key for API_TOKEN">
        <constraints nullable="false"
                     primaryKey="true"
                     primaryKeyName="pk_api_token"/>
      </column>
      <column name="USER_ID" type="BIGINT" remarks="foreign key to CORE_USER.PARTY_ID">
        <constraints nullable="false"
                     foreignKeyName="fk_api_token_core_user_party_id"/>
      </column>
      <column name="UUID" type="VARCHAR(36)" remarks="Unique UUID to identify a token in database">
        <constraints nullable="false" unique="true"/>
      </column>
      <column name="NAME" type="VARCHAR(255)">
        <constraints nullable="false"/>
      </column>
      <column name="PERMISSIONS" type="VARCHAR(50)" remarks="READ for GET and READ_WRITE for all methods">
        <constraints nullable="false"/>
      </column>
      <column name="CREATED_ON" type="DATETIME">
        <constraints nullable="false"/>
      </column>
      <column name="EXPIRY_DATE" type="VARCHAR(10)">
        <constraints nullable="false"/>
      </column>
      <column name="LAST_USAGE" type="DATETIME">
      </column>
    </createTable>

    <createIndex tableName="API_TOKEN"
                 indexName="idx_fk_api_token_user_id">
      <column name="USER_ID"/>
    </createIndex>
  </changeSet>

  <changeSet id="tm-7.1.0-fix-description-type-in-third-party-server" author="jprioux" dbms="mariadb">
    <modifyDataType tableName="THIRD_PARTY_SERVER" columnName="DESCRIPTION" newDataType="CLOB"/>
  </changeSet>

  <changeSet id="tm-7.1.0-fix-description-default-value-in-third-party-server" author="jprioux">
    <addDefaultValue tableName="THIRD_PARTY_SERVER" columnName="DESCRIPTION" defaultValue=""/>
    <update tableName="THIRD_PARTY_SERVER">
      <column name="DESCRIPTION" value=""/>
      <where>DESCRIPTION IS NULL</where>
    </update>
  </changeSet>

</databaseChangeLog>
